Dim Shared As Integer lowfz,highfz,zequaltype=1
Dim Shared As Single lowgz,midgz,highgz
lowfz=200
highfz=8000
lowgz=2.0
midgz=1.0
highgz=1.2

  ' Filter #0 (bass band)
Dim Shared ez_bf   As Single        ' Frequency/100000.0
Dim Shared ez_f0p0 As Single        ' Poles ...
Dim Shared ez_f0p1 As Single       
Dim Shared ez_f0p2 As Single
Dim Shared ez_f0p3 As Single 

  ' Filter #1 (Low band)
Dim Shared ez_lf   As Single        ' Frequency/100000.0
Dim Shared ez_f1p0 As Single        ' Poles ...
Dim Shared ez_f1p1 As Single       
Dim Shared ez_f1p2 As Single
Dim Shared ez_f1p3 As Single 

  ' Filter #2 (High band)
Dim Shared ez_hf   As Single        ' Frequency/100000.0
Dim Shared ez_f2p0 As Single        ' Poles ...
Dim Shared ez_f2p1 As Single       
Dim Shared ez_f2p2 As Single
Dim Shared ez_f2p3 As Single 

  ' Sample history buffer
Dim Shared ez_s1 As Single       ' Sample data minus 1
Dim Shared ez_s2 As Single       '                   2
Dim Shared ez_s3 As Single       '                   3

  ' Gain Controls
Dim Shared ez_lowgz As Single        ' low  gain
Dim Shared ez_midgz As Single        ' mid  gain
Dim Shared ez_highgz As Single       ' high gain
 

  ' Filter #0 (bass band)
Dim Shared ez2_bf   As Single        ' Frequency/100000.0
Dim Shared ez2_f0p0 As Single        ' Poles ...
Dim Shared ez2_f0p1 As Single       
Dim Shared ez2_f0p2 As Single
Dim Shared ez2_f0p3 As Single 

  ' Filter #1 (Low band)
Dim Shared ez2_lf   As Single        ' Frequency/100000.0
Dim Shared ez2_f1p0 As Single        ' Poles ...
Dim Shared ez2_f1p1 As Single       
Dim Shared ez2_f1p2 As Single
Dim Shared ez2_f1p3 As Single 

  ' Filter #2 (High band)
Dim Shared ez2_hf   As Single        ' Frequency/100000.0
Dim Shared ez2_f2p0 As Single        ' Poles ...
Dim Shared ez2_f2p1 As Single       
Dim Shared ez2_f2p2 As Single
Dim Shared ez2_f2p3 As Single 

  ' Sample history buffer
Dim Shared ez2_s1 As Single       ' Sample data minus 1
Dim Shared ez2_s2 As Single       '                   2
Dim Shared ez2_s3 As Single       '                   3

  ' Gain Controls
Dim Shared ez2_lowgz As Single        ' low  gain
Dim Shared ez2_midgz As Single        ' mid  gain
Dim Shared ez2_highgz As Single       ' high gain

function zequcalcul1 (byval sample as single) as Single
  ' Locals
  dim as Single  l,m,h      ' Low / Mid / High - Sample Values
  dim as Single  g

  ' Filter #1 (lowpass)
  g=(ez_lf)
  ez_f1p0  += ((sample - ez_f1p0+1e-5)*g)

  l = (ez_f1p0)

  ' Filter #2 (highpass)
  g=(ez_hf)
  ez_f2p0  += ((sample - ez_f2p0+1e-5)*g)

  h = (sample - ez_f2p0)

  ' Calculate midrange (signal - (low + high))
  m = (sample) - (h + l)

  ' Scale, Combine and store
  l         *= ((ez_lowgz))
  m         *= ((ez_midgz))
  h         *= ((ez_highgz))


  return (l+m+h) 
end function 
function zequcalcul2 (byval sample as single) as Single
  ' Locals
  dim as Single  l,m,h      ' Low / Mid / High - Sample Values
  dim as Single  g

  ' Filter #1 (lowpass)
  g=(ez_lf)
  ez_f1p0  += ((sample - ez_f1p0+1e-5)*g)
  ez_f1p1  += ((ez_f1p0 - ez_f1p1)*g)

  l = (ez_f1p1)

  ' Filter #2 (highpass)
  g=(ez_hf)
  ez_f2p0  += ((sample - ez_f2p0+1e-5)*g)
  ez_f2p1  += ((ez_f2p0 - ez_f2p1)*g)

  h = (ez_s1 - ez_f2p1)

  ' Calculate midrange (signal - (low + high))
  m = (ez_s1) - (h + l)

  ' Scale, Combine and store
  l         *= ((ez_lowgz))
  m         *= ((ez_midgz))
  h         *= ((ez_highgz))

  ' Shuffle history buffer
  ez_s1   = sample                

  return (l+m+h) 
end Function
function zequcalcul3 (byval sample as single) as Single
  ' Locals
  dim as Single  l,m,h      ' Low / Mid / High - Sample Values
  dim as Single  g

  ' Filter #1 (lowpass)
  g=(ez_lf)
  ez_f1p0  += ((sample - ez_f1p0+1e-5)*g)
  ez_f1p1  += ((ez_f1p0 - ez_f1p1)*g)
  ez_f1p2  += ((ez_f1p1 - ez_f1p2)*g)

  l = (ez_f1p2)

  ' Filter #2 (highpass)
  g=(ez_hf)
  ez_f2p0  += ((sample - ez_f2p0+1e-5)*g)
  ez_f2p1  += ((ez_f2p0 - ez_f2p1)*g)
  ez_f2p2  += ((ez_f2p1 - ez_f2p2)*g)

  h = (ez_s2 - ez_f2p2)

  ' Calculate midrange (signal - (low + high))
  m = (ez_s2) - (h + l)

  ' Scale, Combine and store
  l         *= ((ez_lowgz))
  m         *= ((ez_midgz))
  h         *= ((ez_highgz))

  ' Shuffle history buffer
  ez_s2   = ez_s1
  ez_s1   = sample                

  return (l+m+h) 
end Function
function zequcalcul4 (byval sample as single) as Single
  ' Locals
  dim as Single  l,m,h      ' Low / Mid / High - Sample Values
  dim as Single  g

  ' Filter #1 (lowpass)
  g=(ez_lf)
  ez_f1p0  += ((sample - ez_f1p0+1e-5)*g)
  ez_f1p1  += ((ez_f1p0 - ez_f1p1)*g)
  ez_f1p2  += ((ez_f1p1 - ez_f1p2)*g)
  ez_f1p3  += ((ez_f1p2 - ez_f1p3)*g)

  l = (ez_f1p3)

  ' Filter #2 (highpass)
  g=(ez_hf)
  ez_f2p0  += ((sample - ez_f2p0+1e-5)*g)
  ez_f2p1  += ((ez_f2p0 - ez_f2p1)*g)
  ez_f2p2  += ((ez_f2p1 - ez_f2p2)*g)
  ez_f2p3  += ((ez_f2p2 - ez_f2p3)*g)

  h = (ez_s3 - ez_f2p3)

  ' Calculate midrange (signal - (low + high))
  m = (ez_s3) - (h + l)

  ' Scale, Combine and store
  l         *= ((ez_lowgz))
  m         *= ((ez_midgz))
  h         *= ((ez_highgz))

  ' Shuffle history buffer
  ez_s3   = ez_s2
  ez_s2   = ez_s1
  ez_s1   = sample                

  return (l+m+h) 
end Function

function zequcalcul1_2 (byval sample as single) as Single
  ' Locals
  dim as Single  l,m,h      ' Low / Mid / High - Sample Values
  dim as Single  g

  ' Filter #1 (lowpass)
  g=(ez2_lf)
  ez2_f1p0  += ((sample - ez2_f1p0+1e-5)*g)

  l = (ez2_f1p0)

  ' Filter #2 (highpass)
  g=(ez2_hf)
  ez2_f2p0  += ((sample - ez2_f2p0+1e-5)*g)

  h = (sample - ez2_f2p0)

  ' Calculate midrange (signal - (low + high))
  m = (sample) - (h + l)

  ' Scale, Combine and store
  l         *= ((ez2_lowgz))
  m         *= ((ez2_midgz))
  h         *= ((ez2_highgz))


  return (l+m+h) 
end function 
function zequcalcul2_2 (byval sample as single) as Single
  ' Locals
  dim as Single  l,m,h      ' Low / Mid / High - Sample Values
  dim as Single  g

  ' Filter #1 (lowpass)
  g=(ez2_lf)
  ez2_f1p0  += ((sample - ez2_f1p0+1e-5)*g)
  ez2_f1p1  += ((ez2_f1p0 - ez2_f1p1)*g)

  l = (ez2_f1p1)

  ' Filter #2 (highpass)
  g=(ez2_hf)
  ez2_f2p0  += ((sample - ez2_f2p0+1e-5)*g)
  ez2_f2p1  += ((ez2_f2p0 - ez2_f2p1)*g)

  h = (ez2_s1 - ez2_f2p1)

  ' Calculate midrange (signal - (low + high))
  m = (ez2_s1) - (h + l)

  ' Scale, Combine and store
  l         *= ((ez2_lowgz))
  m         *= ((ez2_midgz))
  h         *= ((ez2_highgz))

  ' Shuffle history buffer
  ez2_s1   = sample                

  return (l+m+h) 
end Function
function zequcalcul3_2 (byval sample as single) as Single
  ' Locals
  dim as Single  l,m,h      ' Low / Mid / High - Sample Values
  dim as Single  g

  ' Filter #1 (lowpass)
  g=(ez2_lf)
  ez2_f1p0  += ((sample - ez2_f1p0+1e-5)*g)
  ez2_f1p1  += ((ez2_f1p0 - ez2_f1p1)*g)
  ez2_f1p2  += ((ez2_f1p1 - ez2_f1p2)*g)

  l = (ez2_f1p2)

  ' Filter #2 (highpass)
  g=(ez2_hf)
  ez2_f2p0  += ((sample - ez2_f2p0+1e-5)*g)
  ez2_f2p1  += ((ez2_f2p0 - ez2_f2p1)*g)
  ez2_f2p2  += ((ez2_f2p1 - ez2_f2p2)*g)

  h = (ez2_s2 - ez2_f2p2)

  ' Calculate midrange (signal - (low + high))
  m = (ez2_s2) - (h + l)

  ' Scale, Combine and store
  l         *= ((ez2_lowgz))
  m         *= ((ez2_midgz))
  h         *= ((ez2_highgz))

  ' Shuffle history buffer
  ez2_s2   = ez2_s1
  ez2_s1   = sample                

  return (l+m+h) 
end Function
function zequcalcul4_2 (byval sample as single) as single
  ' Locals
  dim as Single  l,m,h      ' Low / Mid / High - Sample Values
  dim as Single  g

  ' Filter #1 (lowpass)
  g=(ez2_lf)
  ez2_f1p0  += ((sample - ez2_f1p0+1e-5)*g)
  ez2_f1p1  += ((ez2_f1p0 - ez2_f1p1)*g)
  ez2_f1p2  += ((ez2_f1p1 - ez2_f1p2)*g)
  ez2_f1p3  += ((ez2_f1p2 - ez2_f1p3)*g)

  l = (ez2_f1p3)

  ' Filter #2 (highpass)
  g=(ez2_hf)
  ez2_f2p0  += ((sample - ez2_f2p0+1e-5)*g)
  ez2_f2p1  += ((ez2_f2p0 - ez2_f2p1)*g)
  ez2_f2p2  += ((ez2_f2p1 - ez2_f2p2)*g)
  ez2_f2p3  += ((ez2_f2p2 - ez2_f2p3)*g)

  h = (ez2_s3 - ez2_f2p3)

  ' Calculate midrange (signal - (low + high))
  m = (ez2_s3) - (h + l)

  ' Scale, Combine and store
  l         *= ((ez2_lowgz))
  m         *= ((ez2_midgz))
  h         *= ((ez2_highgz))

  ' Shuffle history buffer
  ez2_s3   = ez2_s2
  ez2_s2   = ez2_s1
  ez2_s1   = sample                

  return (l+m+h) 
end Function
Sub zresetequalizer()
Dim As Integer mixfreq
mixfreq=fbs_get_plugrate()
If mixfreq<4000 Then mixfreq=4000
If mixfreq>100000 Then mixfreq=100000
'mixfreq=44100
ez_lf =  2 * sin(3.1416 * (lowfz / mixfreq))
ez_hf =  2 * sin(3.1416 * (highfz / mixfreq))
ez2_lf = 2 * sin(3.1416 * (lowfz / mixfreq))
ez2_hf = 2 * sin(3.1416 * (highfz / mixfreq))
  ez_lowgz=lowgz
  ez_midgz=midgz
  ez_highgz=highgz	
  ez2_lowgz=lowgz
  ez2_midgz=midgz
  ez2_highgz=highgz	

  ez_f0p0 =1e-5
  ez_f0p1 =1e-5
  ez_f0p2 =1e-5
  ez_f0p3 =1e-5
  ez_f1p0 =1e-5
  ez_f1p1 =1e-5
  ez_f1p2 =1e-5
  ez_f1p3 =1e-5
  ez_f2p0 =1e-5
  ez_f2p1 =1e-5
  ez_f2p2 =1e-5
  ez_f2p3 =1e-5
  ez_s1 =1e-5
  ez_s2 =1e-5
  ez_s3 =1e-5

  ez2_f0p0 =1e-5
  ez2_f0p1 =1e-5
  ez2_f0p2 =1e-5
  ez2_f0p3 =1e-5
  ez2_f1p0 =1e-5
  ez2_f1p1 =1e-5
  ez2_f1p2 =1e-5
  ez2_f1p3 =1e-5
  ez2_f2p0 =1e-5
  ez2_f2p1 =1e-5
  ez2_f2p2 =1e-5
  ez2_f2p3 =1e-5
  ez2_s1 =1e-5
  ez2_s2 =1e-5
  ez2_s3 =1e-5
  
end sub 

